"""
==========
自环
==========

自环是指从同一节点出发并终止于该节点的边。
此示例展示了如何使用 `nx_pylab` 绘制自环。

"""

import networkx as nx
import matplotlib.pyplot as plt

# 创建一个图并给节点0添加自环
G = nx.complete_graph(3, create_using=nx.DiGraph)
G.add_edge(0, 0)
pos = nx.circular_layout(G)

# 从2.6版本开始，默认情况下自环边采用与普通边相同的样式绘制
# 其他边
nx.draw(G, pos, with_labels=True)

# 为剩余节点添加自环
edgelist = [(1, 1), (2, 2)]
G.add_edges_from(edgelist)

# 使用不同的格式绘制新添加的自环
nx.draw_networkx_edges(G, pos, edgelist=edgelist, arrowstyle="<|-", style="dashed")

plt.show()
